#include <ri.h>
#include <stdio.h>

main ()
{
	RtFloat ka, kd, ks;
	RtPoint from, to;
	RtFloat intensity = .5;

	from[0] = 0; from[1] = 0; from[2] = -.5; 
	to[0] = 0; to[1] = 0; to[2] = 0; 

	RiBegin (RI_NULL); /* Start Renderer */
		
		RiLightSource("distantlight", "intensity", &intensity, RI_NULL);	
		RiLightSource("pointlight", "intensity", &intensity, "from", from, RI_NULL);	
		RiLightSource("spotlight", "intensity", &intensity, "from", from, "to", to, RI_NULL);	
		RiLightSource("ambientlight", "intensity", &intensity, RI_NULL);

		RiProjection ("orthographic", RI_NULL);

		RiWorldBegin ();		

			RiAttributeBegin();
				
				ka = 0.4; kd = .6; ks = .7;

				RiScale( 0.15, 0.15, 0.15 );
				RiTranslate( -5.0, 1.2,0.0 );
				RiRotate( -35.0, 0.0, 1.0, 0.0 );
				RiRotate( 90.0, -1.0, 0.0, 0.0 );
				RiSurface ("brick", (RtToken)"Ka", (RtPointer) &ka, 
					(RtToken) "Kd", (RtPointer) &kd, 
					(RtToken) "Ks", (RtPointer) &ks, RI_NULL);
				RiReadArchive("teapot.rib", RI_NULL, RI_NULL);

			RiAttributeEnd();

			RiAttributeBegin();

				ka = .4; kd = .6; ks = .7;

				RiScale( 0.15, 0.15, 0.15 );
				RiTranslate( 0.0, 1.2,0.0 );
				RiRotate( -35.0, 0.0, 1.0, 0.0 );
				RiRotate( 90.0, -1.0, 0.0, 0.0 );
				RiSurface ("funkyglass", (RtToken)"Ka", (RtPointer) &ka, 
					(RtToken) "Kd", (RtPointer) &kd, 
					(RtToken) "Ks", (RtPointer) &ks, RI_NULL);
				RiReadArchive("teapot.rib", RI_NULL, RI_NULL);

			RiAttributeEnd();

			RiAttributeBegin();

				ka = .4; kd = .6;ks = .7;

				RiScale( 0.15, 0.15, 0.15 );
				RiTranslate( 5.0, 1.2,0.0 );
				RiRotate( -35.0, 0.0, 1.0, 0.0 );
				RiRotate( 90.0, -1.0, 0.0, 0.0 );
				RiSurface ("ceramic", (RtToken)"Ka", (RtPointer) &ka, 
					(RtToken) "Kd", (RtPointer) &kd, 
					(RtToken) "Ks", (RtPointer) &ks, RI_NULL);
				RiReadArchive("teapot.rib", RI_NULL, RI_NULL);

			RiAttributeEnd();

			from[0] = 0; from[1] = 0; from[2] = -2.5; 

			RiAttributeBegin();

				ka = .9; kd = .9; ks = .9;

				RiScale( 0.15, 0.15, 0.15 );
				RiTranslate( -5.0, -3.2,0.0 );
				RiLightSource("pointlight", "intensity", &intensity, "from", from, RI_NULL);	
				RiRotate( -35.0, 0.0, 1.0, 0.0 );
				RiRotate( 90.0, -1.0, 0.0, 0.0 );
				RiSurface ("greenmarble", (RtToken)"Ka", (RtPointer) &ka, 
					(RtToken) "Kd", (RtPointer) &kd, 
					(RtToken) "Ks", (RtPointer) &ks, RI_NULL);
				RiReadArchive("teapot.rib", RI_NULL, RI_NULL);

			RiAttributeEnd();

			RiAttributeBegin();
	
				ka = .9; kd = .9; ks = .9;

				RiScale( 0.15, 0.15, 0.15 );
				RiTranslate( 0.0, -3.2,0.0 );
				RiLightSource("pointlight", "intensity", &intensity, "from", from, RI_NULL);	
				RiRotate( -35.0, 0.0, 1.0, 0.0 );
				RiRotate( 90.0, -1.0, 0.0, 0.0 );
				RiSurface ("plank", (RtToken)"Ka", (RtPointer) &ka, 
					(RtToken) "Kd", (RtPointer) &kd, 
					(RtToken) "Ks", (RtPointer) &ks, RI_NULL);
				RiReadArchive("teapot.rib", RI_NULL, RI_NULL);

			RiAttributeEnd();

			RiAttributeBegin();

				ka = .9; kd = .9; ks = .9;

				RiScale( 0.15, 0.15, 0.15 );
				RiTranslate( 5.0, -3.2,0.0 );
				RiLightSource("pointlight", "intensity", &intensity, "from", from, RI_NULL);	
				RiRotate( -35.0, 0.0, 1.0, 0.0 );
				RiRotate( 90.0, -1.0, 0.0, 0.0 );
				RiSurface ("screen", (RtToken)"Ka", (RtPointer) &ka, 
					(RtToken) "Kd", (RtPointer) &kd, 
					(RtToken) "Ks", (RtPointer) &ks, RI_NULL);
				RiReadArchive("teapot.rib", RI_NULL, RI_NULL);

			RiAttributeEnd();

		RiWorldEnd();

	RiEnd(); /* Clean up */

}
